// Keyboardstand

// The width of the baseplate
Base_Width = 30;
// Depth of your keyboard, this should be near your actual keyboard depth
Keyboard_Depth = 150;
// Angle at which your keyboard will stand
Keyboard_Angle = 45;
// A general base if you want to raise your keyboard completely (lower than 3 might cause instability)
Keyboard_Platform = 10;
// The height of the keyboard stop, you may adjust this to prevent your keyboard from slipping
Keyboard_Front_Stop = 16;


// Internal variables
// DO NOT MODIFY

bw = Base_Width;
kd = Keyboard_Depth;
ka = Keyboard_Angle;
kp = Keyboard_Platform;
ks = Keyboard_Front_Stop;

// internal modules
//prism
module prism(l, w, h)
{
    polyhedron(
        points=[[0,0,0], [l,0,0], [l,w,0], [0,w,0], [0,w,h], [l,w,h]],
        faces=[[0,1,2,3], [5,4,3,2], [0,4,5,1], [0,3,4], [5,2,1]]);
}


// keyboard stand
module Keyboard_Stand()
{
    // calculate the base depth according to angle and keyboard_depth
    bd = cos(ka)*kd;
    // calculate the base height according to angle and keyboard_depth
    bh = sin(ka)*kd;
    
    difference()
    {
        union()
        {
            // baseplate
            cube([bw, bd, kp]);
            // holding Prism
            translate([bw/2 -5,0, kp])
            prism(10, bd, bh);
            // stopper
            translate([bw/2 -5,0, kp])
            rotate([ka, 0, 0])
            cube([10, 8, ks]);
        }
        union()
        {
            translate([bw/2-6, 12, kp+0.01])
            prism(12, bd-20, bh-20);
        }
    }
    
}


// Call module
Keyboard_Stand();